;;; **********************************************************************
;;; ** THOR Basic++                                                     **
;;; ** A free Basic for the Atari 8 Bit series               		**
;;; ** (c) 2015 THOR Software, Thomas Richter                           **
;;; ** This is based on Atari Basic, as developed by			**
;;; ** Paul Laughton and Kathleen O'Brien, Shepardson Microsystems	**
;;; ** as found in: The Atari BASIC SOURCE BOOK	by Bill Wilkinson	**
;;; ** Compute! Publications (1983)					**
;;; ** $Id: statementvector.asm,v 1.4 2015/09/05 20:28:48 thor Exp $	**
;;; **                                                                  **
;;; ** In this module:   The vector defining all statements             **
;;; **********************************************************************

	.include "basicmacros.i"
	.include "basicstatements.i"
	.include "basicexpression.i"
	.include "basicstack.i"
	.include "basicmain.i"
	.include "syntax.i"
	
	.segment "BasMain"

StatementCounter	.set	$0
.macro	addVector token, location
	.word location-1
	.if token<>StatementCounter
	.error "Statement token definition mismatch"
	.endif
StatementCounter	.set StatementCounter+1 
.endmacro
	
	;; This vector contains for each statement the
	;; address of the subroutine that is used to execute the
	;; statement
	.global StatementVector
StatementVector:
	addVector REMToken,ExecuteRem
	addVector DATAToken,ExecuteData
	addVector INPUTToken,ExecuteInput
	addVector COLORToken,ExecuteColor
	addVector LISTToken,ExecuteList
	addVector ENTERToken,ExecuteEnter
	addVector LETToken,ExecuteLet
	addVector IFToken,ExecuteIf
	addVector FORToken,ExecuteFor
	addVector NEXTToken,ExecuteNext
	addVector GOTOToken,ExecuteGoto
	addVector GO_TOToken,ExecuteGoto	;this exists twice, once for GOTO and once for GO TO
	addVector GOSUBToken,ExecuteGosub
	addVector TRAPToken,ExecuteTrap
	addVector BYEToken,ExecuteBye
	addVector CONTToken,ExecuteCont
	addVector COMToken,ExecuteCom
	addVector CLOSEToken,ExecuteClose
	addVector CLRToken,ExecuteClr
	addVector DEGToken,ExecuteDeg
	addVector DIMToken,ExecuteDim
	addVector ENDToken,ExecuteEnd
	addVector NEWToken,ExecuteNew
	addVector OPENToken,ExecuteOpen
	addVector LOADToken,ExecuteLoad
	addVector SAVEToken,ExecuteSave
	addVector STATUSToken,ExecuteStatus
	addVector NOTEToken,ExecuteNote
	addVector POINTToken,ExecutePoint
	addVector XIOToken,ExecuteXIO
	addVector ONToken,ExecuteOn
	addVector POKEToken,ExecutePoke
	addVector PRINTToken,ExecutePrint
	addVector RADToken,ExecuteRad
	addVector READToken,ExecuteRead
	addVector RESTOREToken,ExecuteRestore
	addVector RETURNToken,ExecuteReturn
	addVector RUNToken,ExecuteRun
	addVector STOPToken,ExecuteStop
	addVector POPToken,ExecutePop
	addVector QuestionmarkToken,ExecutePrint	;this also exists twice, once for PRINT and once for ?
	addVector GETToken,ExecuteGet
	addVector PUTToken,ExecutePut
	addVector GRAPHICSToken,ExecuteGraphics
	addVector PLOTToken,ExecutePlot
	addVector POSITIONToken,ExecutePosition
	addVector DOSToken,ExecuteDos
	addVector DRAWTOToken,ExecuteDrawto
	addVector SETCOLORToken,ExecuteSetcolor
	addVector LOCATEToken,ExecuteLocate
	addVector SOUNDToken,ExecuteSound
	addVector LPRINTToken,ExecuteLPrint
	addVector CSAVEToken,ExecuteCSave
	addVector CLOADToken,ExecuteCLoad
	addVector ImplicitLetToken,ExecuteLet
	addVector ErrorToken,ExecuteError
